var User = { id: null, name: null, token: null }; // Objet représentant le futur utilisateur
var Talk = []; // tableau de messasges à remplir plus tard
var UsersConnected = []; // tableau des utilisateurs connectés à remplir plus tard

var $CreaLog = $('#CreaLog');
var $FormLogin = $('#FormLogin');
var $InputLogin = $FormLogin.find('#User');
var $InputPassword = $FormLogin.find('#Password');
var $Connected = $('#Connected');
var $MessagesContainer = $('#MessagesContainer');
var $ConnectedUsers = $('#ConnectedUsers');
var $PostYourMessage = $('#PostYourMessage');
var $MessageContent =  $('#MessageContent');

var $alertSuccess = $('#alert-success');
var $alertError = $('#alert-error');

// fonction qui masque les alertes
function hideAlerts() {
  $alertSuccess.empty().hide();
  $alertError.empty().hide();
}

// fonction permettant de générer l'URL spécifique de l'API
function RequestApi(Action, Params, Done){
  var Values = '';
  for (var i = 0; i < Params.length; i++) {
    Values+="/"+Params[i];
  }
  var requete = $.ajax({
    url : 'http://greenvelvet.alwaysdata.net/kwick/api/'+ Action + Values,
    dataType : 'jsonp'
  });

  requete.done(function(response) {
    if (response.kwick.status === "ok") {
      $alertSuccess.show().text('Connexion réussie !');
      setTimeout(hideAlerts, 5000);

      if (response.result.status === "failure") {
        $alertError.show().text('Vous avez du faire une erreur');
        setTimeout(hideAlerts, 5000);
      }
      else if(response.result.status == "done"){
        $alertSuccess.show().text('Connexion réussie !');
        setTimeout(hideAlerts, 5000);
        Done(response.result);
      }
    }
  });

};

// LOGIN
$('#FormLogin') .submit(function(event) {
  event.preventDefault();
  var Username = $('#User2').val();
  var Password = $('#Password2').val();


  //Je vérifie si le loggin est existant.
  // Si c'est ok j'affiche le User et la déconnexion en haut.
  // Ainsi que la div contenant les messages et la liste des utilisateurs connectés.
  RequestApi("login", [Username,Password], function(response) {

    $alertSuccess.show().text('Connexion réussie !');
    setTimeout(hideAlerts, 5000);
      User.token =  response.token;
    User.id =  response.id;

    $CreaLog.hide();
    $Connected.show();
    $MessagesContainer.show();
    $ConnectedUsers.show();
    $PostYourMessage.show();
    GetMessages();
    GetConnectedUsers();
    ActualDate();
  });
});

// CREER COMPTE
$('#FormAccount') .submit(function(event) {
  event.preventDefault();
  // je récupère la valeur de USER et Password
  var User = $('#User').val();
  var Password = $('#Password').val();

  var requete =$.ajax({
    url : 'http://greenvelvet.alwaysdata.net/kwick/api/signup/'+ User +'/'+ Password,
    dataType : 'jsonp'
  });


  // J'affiche un message de validation de création de compte
  // Puis je masque les formaulaires de création de compte et de loggin
  requete.done(function(response) {
    if (response.kwick.status === "ok") {
      $alertSuccess.show().text('Création de compte réussie !');
      setTimeout(hideAlerts, 5000);
    }
  });
});

// Poster un message
$('#FormYourMessage') .submit(function(event) {
  event.preventDefault();
  // je récupère le contenu du message
  var MessageContent = $('#MessageContent').val();
  //http://greenvelvet.alwaysdata.net/kwick/api/say/46efaa193f9a7d8dace33a94e9397842/4/premier%20message
  var requete =$.ajax({
    url : 'http://greenvelvet.alwaysdata.net/kwick/api/say/'+ User.token +'/'+ User.id +'/'+ MessageContent,
    dataType : 'jsonp'
  });

  // J'affiche un message de validation de post du message
  requete.done(function(response) {
    if (response.kwick.status === "ok") {
      $alertSuccess.show().text('Votre message a été posté !');
      setTimeout(hideAlerts, 5000);
    }
  });
});

// LOGOUT
$('#Disconnect') .click(function(event) {
  event.preventDefault();

  var requete =$.ajax({
    //http://greenvelvet.alwaysdata.net/kwick/logout/token/user_id
    url : 'http://greenvelvet.alwaysdata.net/kwick/api/logout/'+ User.token +'/'+ User.id,
    dataType : 'jsonp'
  });

  // Lorsque la requete est faite, je recharge la page pour revenir en configuration initiale
  requete.done(function(){
    window.location.reload();
  });

});

// Récupérer les messages
function GetMessages (){

    // http://greenvelvet.alwaysdata.net/kwick/api/talk/list/46efaa193f9a7d8dace33a94e9397842/1327171160
    var requete =$.ajax({
      url : 'http://greenvelvet.alwaysdata.net/kwick/api/talk/list/'+ User.token +'/'+ 0 ,
      dataType : 'jsonp'
    });

    // Si la requette est ok je fais une boucle
    requete.done(function(response) {
      if (response.kwick.status === "ok"){
        var messages = response.result.talk.slice(-10).reverse();
        var ListMesssages = "";


        for (var i = 0; i < messages.length; i++) {

          // Convertir la date unix
          var Timestamp = new Date (messages[i].timestamp*1000);
          var UTCstring = Timestamp.toUTCString();
          // Mon, 03 Jul 2006 21:44:38 GMT

          // j'affiche les messages ainsi que le user et la date qui va avec
          ListMesssages += '<strong>'+messages[i].user_name+'</strong>' + '<p>'+ messages[i].content +'</p><small>'+ UTCstring +'</small> <div class="Separate"></div>';
        }
        $('#MessagesContainer > div').html(ListMesssages);
      }
    });

    // Je recharge les messages toutes les 10 secondes
    setTimeout(GetMessages,10000);

  };

// Heure actuelle
function ActualDate() {
    var d = new Date();
    document.getElementById("Date").innerHTML = d.toUTCString();
}

// Transformer la date unix en locale
function FormatTimestamp (value) {
  var date = new Date(value*1000);
  var hours = date.getHours();
  var minutes = "0" + date.getMinutes();
  var seconds = "0" + date.getSeconds();
  var formattedTime = hours + ':' + minutes.substr(-2) + ':' + seconds.substr(-2);
};

// Récupérer la liste des utilisateurs connectés
function GetConnectedUsers(){

    // http://greenvelvet.alwaysdata.net/kwick/api/user/logged/46efaa193f9a7d8dace33a94e9397842
    var requete =$.ajax({
      url : 'http://greenvelvet.alwaysdata.net/kwick/api/user/logged/'+ User.token ,
      dataType : 'jsonp'
    });

    // Si la requette est ok je fais une boucle
    requete.done(function(response) {
      if (response.kwick.status === "ok") {
        var UsersConnected = response.result.user.reverse();
        var ListConnectedUsers = "";

        for (var i = 0; i < UsersConnected.length; i++) {
          // j'affiche les messages ainsi que le user et la date qui va avec
          ListConnectedUsers += '<li>'+UsersConnected[i]+'</li>';
        }
        $('#ConnectedUsers > ul').html(ListConnectedUsers);
      }
    });
    // Je recharge la liste toutes les 10 secondes
    setTimeout(GetConnectedUsers,10000);
  };
